### 1. setup
```shell 
    npm i --save-dev react-dynamic-router-loader
```
### 2. using
```javascript
    // webpack.config.js
    ...
    loader: "react-dynamic-router-loader",
    options: {
        // Loading Component
        asyncDefaultComponent: './components/loading.jsx'
    }
    ...
```
```javascript
    // ./components/loading.jsx
    import React from 'react';

    const _AsyncComponent = (loaderComponent, callback) => (
        class _AsyncComponent extends React.Component {
            state = {
                Component: null
            }

            async componentWillMount() {
                let Component = await loaderComponent();

                this.setState({
                    Component
                });
            }

            render() {
                const { Component } = this.state;

                return (Component) ? 
                            <Component {...this.props} /> : 
                            callback();
            }
        }
    );

    // Currently only to do so
    module.exports = _AsyncComponent;
```
```javascript
    // Reactjs Code
    ...
    <MyComponent component={require(
                                /* webpackChunkName: "index" */
                                'path/my-component.jsx')} />
    ...
    // webpackChunkName
    // the "import" feature of the CommonJS API for webpack2
    
    // Reactjs Code 2
    class MyComponent extends React.Component {
        preRender(){
            // Don't use props. 
            // because this.props not equal MyComponent's props

            return (
                <div>My Loading View</div>
            );
        }
    }
```
### 3. Webpack.config.js info
```javascript
    // webpack config must has client and server config

    let clientConfig = {
        ...
        // client config
        ...
    };

    let serverConfig = {
        ...
        // server config
        ...
    };

    module.exports = [serverConfig, clientConfig]
```
<br />
    emmmm.....Hope to improve